import png
import psycopg
import json

COLORS = (
    (128, 0, 0),
    (130, 40, 40),
    (141, 83, 59),
    (153, 102, 117),
    (153, 102, 169),
    (128, 0, 128),
    (101, 0, 155),
    (72, 0, 225),
    (4, 0, 208),
    (0, 68, 220),
    (1, 114, 226),
    (1, 159, 232),
    (11, 175, 162),
    (23, 179, 77),
    (0, 212, 28),
    (0, 255, 0),
    (128, 255, 0),
    (200, 255, 0),
    (255, 255, 0),
    (255, 219, 0),
    (255, 182, 0),
    (255, 146, 0),
    (255, 109, 0),
    (255, 73, 0),
    (255, 0, 0),
    (255, 0, 128),
    (255, 105, 180),
    (255, 0, 255),
    (168, 0, 185)
)


conn = psycopg.connect("dbname=power")
with conn:
    with conn.cursor() as cur:
        cur.execute("""
            select 
                    date_trunc('day', time)::date::varchar as day,
                    avg(temperature)::int as temperature
                from room_climate_measurement_t
                where
                    category = 'Outdoor' and
                    location = 'Outdoor' and
                    extract('hour' from time) = 12 and
                    extract('year' from time) = 2022
                group by day
                order by day
        """)
        res = cur.fetchall()
        temperatures = [ x[1] for x in res ]
        # print(json.dumps(temperatures))
conn.close()

min_t = min(temperatures)
max_t = max(temperatures)
span_t = max_t - min_t
# print(f"{min_t=}, {max_t=}, {span_t=}")

temperatures = [ int(x/2) for x in temperatures ]
min_t = min(temperatures)
max_t = max(temperatures)
span_t = max_t - min_t
# print(f"{min_t=}, {max_t=}, {span_t=}")

temperatures = [ x - min_t for x in temperatures ]
min_t = min(temperatures)
max_t = max(temperatures)
span_t = max_t - min_t
# print(f"{min_t=}, {max_t=}, {span_t=}")


height = 350

img = []
for i in range(height):
    row = ()
    for t in temperatures:
        for j in range(3):
            row += COLORS[t]
    img.append(row)

width = len(temperatures) * 3

with open('temperature.png', 'wb') as f:
    w = png.Writer(width, height, greyscale=False)
    w.write(f, img)
